# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from re import compile
from time import strftime, time

DEBUG = False
DT = True

# <class 'autocomplete.PrefixRecognizer.PrefixRecognizer'>
pattern = compile(r"\<class '(?P<name>[\w\.]+)'\>")
t = time()

def __instance_to_class_name(instance):
	match = pattern.match(str(type(instance)))
	if match:
		return match.group("name").split(".")[-1]
	else:
		return instance

def __log(instance, method, message):	
	if DT:
		dt = "%.2f" % (time() - t)
	else:
		dt = ""
		
	print "%s [%s.%s] %s" % (dt, __instance_to_class_name(instance), method, message)

def error(instance, method, message=""):
	__log(instance, method, message)

def debug(instance, method, message=""):
	if DEBUG:
		__log(instance, method, message)
