# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

import gedit

from WindowHelper import WindowHelper


class LaTeXPlugin(gedit.Plugin):
	def __init__(self):
		gedit.Plugin.__init__(self)
		self.__window_helpers = {}
		
	def activate(self, window):
		"""
		Called when 
		* a new gedit window is created
		* the plugin is activated in the plugin settings dialog
		* gedit is started with the plugin loaded
		"""
		self.__window_helpers[window] = WindowHelper(self, window)
	
	def deactivate(self, window):
		"""
		Called when the plugin is deactivated by the user
		"""
		self.__window_helpers[window].deactivate()
		
		del self.__window_helpers[window]
	
	def create_configure_dialog(self):
		"""
		Called when the plugin is to be configured (must return a gtk.Window)
		"""
		from ConfigureDialog import ConfigureDialog
		
		return ConfigureDialog()
