# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from gtk import Window, TEXT_WINDOW_WIDGET, WINDOW_POPUP, Label, \
		CellRendererText, ScrolledWindow, POLICY_AUTOMATIC, Frame, SHADOW_OUT

class DocPopup(Window):
	"""
	A popup showing some documentation at the right of the currently 
	selected proposal
	"""
	
	def __init__(self):
		Window.__init__(self, WINDOW_POPUP)
		
		self.__label = Label()
		self.__label.set_use_markup(True)
		self.__label.set_alignment(0, .5)

		self.__frame = Frame()
		self.__frame.set_shadow_type(SHADOW_OUT)
		self.__frame.add(self.__label)
		
		self.add(self.__frame)
		
		self.__frame.set_size_request(380, 160)
		
		self.__active = False
	
	def set_markup(self, markup):
		self.__label.set_markup(markup)
	
	def set_active(self, active):
		"""
		Shows or hides the popup
		"""
		if active and not self.__active:
			self.show_all()
		elif not active and self.__active:
			self.hide()
		
		self.__active = active
	
	def get_active(self):
		return self.__active
