# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

from os.path import getmtime

from LaTeXPlugin.Logger import debug
from BibTeXModel import BibTeXModel
from BibTeXParser import BibTeXParser
from FileReader import FileReader

class BibTeXFile(object):
	"""
	"""
	def __init__(self, filename):
		self.__model = BibTeXModel()
		self.__parser = BibTeXParser()
		self.__filename = filename
		self.synchronize()
	
	@property
	def model(self):
		return self.__model
	
	@property
	def changed(self):
		return (getmtime(self.__filename) != self.__mtime)
	
	def synchronize(self):
		debug(self, "synchronize", self.__filename)
		try:
			self.__mtime = getmtime(self.__filename)
			self.__model.clear()
			self.__parser.parse(self.__model, FileReader(self.__filename))
		except OSError:
			raise IOError
	