# -*- coding: utf-8 -*-

# This file is part of the Gedit LaTeX Plugin
#
# Copyright (C) 2007 Michael Zeising
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public Licence as published by the Free Software
# Foundation; either version 2 of the Licence, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public Licence for more 
# details.
#
# You should have received a copy of the GNU General Public Licence along with
# this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
# Street, Fifth Floor, Boston, MA  02110-1301, USA

class Profile(object):
	"""
	A build profile
	"""
	def __init__(self):
		self.name = ""
		self.viewer = ""
		self.jobs = []
		self.icon = ""
		self.accel = ""
	
	def __str__(self):
		s = "Profile : " + self.name + "\n"
		for job in self.jobs:
			s += job.get_command() + "\n"
		return s
	
	def get_markup(self):
		"""
		Return a markup representation to be displayed in the settings dialog
		"""
		commands = ", ".join(["<tt>%s</tt>" % job.get_command_name() for job in self.jobs])
		return "<b>%s</b>\n%s" % (self.name, commands)
	